Package net.sf.saxon.type

## Class NumericType

- java.lang.Object
- - net.sf.saxon.type.LocalUnionType
  - - net.sf.saxon.type.NumericType

- All Implemented Interfaces:
    `CastingTarget`, `ItemType`, `PlainType`, `SchemaComponent`, `SchemaType`, `SimpleType`, `UnionType`

      public class NumericType
      extends LocalUnionType
      implements SimpleType

  Singleton class representing the class xs:numeric as defined in XPath 3.1: a union type whose members are xs:double, xs:decimal, and xs:float

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface net.sf.saxon.type.ItemType

      `ItemType.WithSequenceTypeCache`

    - ### Nested classes/interfaces inherited from interface net.sf.saxon.type.SchemaComponent

      `SchemaComponent.ValidationStatus`

  - ### Field Summary

    - ### Fields inherited from interface net.sf.saxon.type.SchemaComponent

      `COMPONENT_FUNCTION_TYPE`

    - ### Fields inherited from interface net.sf.saxon.type.SchemaType

      `DERIVATION_EXTENSION, DERIVATION_LIST, DERIVATION_RESTRICTION, DERIVATION_UNION, DERIVE_BY_SUBSTITUTION`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `allowsDerivation​(int derivation)` | Determines whether derivation (of a particular kind) from this type is allowed, based on the "final" property
    `void` | `analyzeContentExpression​(Expression expression, int kind)` | Analyze an XPath expression to see whether the expression is capable of delivering a value of this type.
    `AtomicSequence` | `atomize​(NodeInfo node)` | Get the typed value of a node that is annotated with this schema type.
    `ValidationFailure` | `checkAgainstFacets​(AtomicValue value, ConversionRules rules)` | Validate an atomic value, which is known to be an instance of one of the member types of the union, against any facets (pattern facets or enumeration facets) defined at the level of the union itself.
    `void` | `checkTypeDerivationIsOK​(SchemaType base, int block)` | Check that this type is validly derived from a given type, following the rules for the Schema Component Constraint "Is Type Derivation OK (Simple)" (3.14.6) or "Is Type Derivation OK (Complex)" (3.4.6) as appropriate.
    `boolean` | `containsListType()` | Ask whether the union contains a list type among its member types
    `PlainType` | `getAtomizedItemType()` | Get the item type of the atomic values that will be produced when an item of this type is atomized
    `SchemaType` | `getBaseType()` | Returns the base type that this type inherits from.
    `java.lang.String` | `getBasicAlphaCode()` | Get an alphabetic code representing the type, or at any rate, the nearest built-in type from which this type is derived.
    `int` | `getBlock()` | Returns the value of the 'block' attribute for this type, as a bit-significant integer with fields such as `SchemaType.DERIVATION_LIST` and `SchemaType.DERIVATION_EXTENSION`.
    `SchemaType` | `getBuiltInBaseType()` | Get the built-in type from which this type is derived by restriction
    `Function` | `getComponentAsFunction()` | Get the schema component in the form of a function item.
    `double` | `getDefaultPriority()` | Get the default priority when this ItemType is used as an XSLT pattern
    `int` | `getDerivationMethod()` | Gets the integer code of the derivation method used to derive this type from its parent.
    `java.lang.String` | `getDescription()` | Get a description of this type for use in error messages.
    `java.lang.String` | `getDisplayName()` | Get the display name of the type: that is, a lexical QName with an arbitrary prefix
    `java.lang.String` | `getEQName()` | Get the name of this type as an EQName, that is, a string in the format Q{uri}local.
    `int` | `getFinalProhibitions()` | Get the types of derivation that are not permitted, by virtue of the "final" property.
    `int` | `getFingerprint()` | Get the fingerprint of the name of this type
    `Genre` | `getGenre()` | Get the genre of this item
    `static NumericType` | `getInstance()` |
    `java.lang.String` | `getName()` | Get the local name of this type
    `java.lang.Iterable<AtomicType>` | `getPlainMemberTypes()` | Get the "plain" types in the transitive membership.
    `AtomicType` | `getPrimitiveItemType()` | Get the primitive item type corresponding to this item type.
    `int` | `getPrimitiveType()` | Get the primitive type corresponding to this item type.
    `int` | `getRedefinitionLevel()` | Get the redefinition level.
    `SequenceType` | `getResultTypeOfCast()` | Get the result type of a cast operation to this union type, as a sequence type.
    `StructuredQName` | `getStructuredQName()` | Get the name of the type as a StructuredQName
    `java.lang.String` | `getSystemId()` | Get the URI of the schema document where the type was originally defined.
    `java.lang.String` | `getTargetNamespace()` | Get the target namespace of this type
    `DoubleValue` | `getTypedValue​(java.lang.CharSequence value, NamespaceResolver resolver, ConversionRules rules)` | Get the typed value corresponding to a given string value, assuming it is valid against this type
    `StructuredQName` | `getTypeName()` | Get the name of this type as a structured QName
    `UType` | `getUType()` | Get the corresponding `UType`.
    `SchemaComponent.ValidationStatus` | `getValidationStatus()` | Get the validation status of this component.
    `int` | `getWhitespaceAction()` | Determine how values of this simple type are whitespace-normalized.
    `boolean` | `isAnonymousType()` | Test whether this is an anonymous type
    `boolean` | `isAtomicType()` | Test whether this Simple Type is an atomic type
    `boolean` | `isAtomizable​(TypeHierarchy th)` | Ask whether values of this type are atomizable
    `boolean` | `isBuiltInType()` | Determine whether this is a built-in type or a user-defined type
    `boolean` | `isComplexType()` | Test whether this SchemaType is a complex type
    `boolean` | `isIdRefType()` | Ask whether this type is an IDREF or IDREFS type.
    `boolean` | `isIdType()` | Ask whether this type is an ID type.
    `boolean` | `isListType()` | Test whether this Simple Type is a list type
    `boolean` | `isNamespaceSensitive()` | Test whether this type is namespace sensitive, that is, if a namespace context is needed to translate between the lexical space and the value space.
    `static boolean` | `isNumericType​(ItemType type)` | Ask whether a given atomic type is numeric, that is, whether it is a subtype of xs:double, xs:float, or xs:decimal
    `boolean` | `isPlainType()` | Determine whether this item type is a plain type (that is, whether it can ONLY match atomic values)
    `boolean` | `isSameType​(SchemaType other)` | Test whether this is the same type as another type.
    `boolean` | `isSimpleType()` | Test whether this SchemaType is a simple type
    `boolean` | `isUnionType()` | Test whether this Simple Type is a union type
    `boolean` | `matches​(Item item, TypeHierarchy th)` | Test whether a given item conforms to this type
    `java.lang.CharSequence` | `postprocess​(java.lang.CharSequence input)` | Reverse any pre-lexical facets, other than whitespace.
    `java.lang.CharSequence` | `preprocess​(java.lang.CharSequence input)` | Apply any pre-lexical facets, other than whitespace.
    `java.lang.String` | `toExportString()` | Return a string representation of this ItemType suitable for use in stylesheet export files.
    `java.lang.String` | `toString()` | Produce a string representation of the type name.
    `ValidationFailure` | `validateContent​(java.lang.CharSequence value, NamespaceResolver nsResolver, ConversionRules rules)` | Check whether a given input string is valid according to this SimpleType

    - ### Methods inherited from class net.sf.saxon.type.LocalUnionType

      `getMemberTypes, isTrueItemType`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.type.ItemType

      `getFullAlphaCode, getNormalizedDefaultPriority`

    - ### Methods inherited from interface net.sf.saxon.type.SchemaType

      `getNearestNamedType`

    - ### Methods inherited from interface net.sf.saxon.type.UnionType

      `explainMismatch`

- - ### Method Detail

    - #### getInstance

          public static NumericType getInstance()

    - #### getTypeName

          public StructuredQName getTypeName()

      Description copied from interface: `PlainType`
      Get the name of this type as a structured QName
      Specified by:
        `getTypeName` in interface `PlainType`
      Specified by:
        `getTypeName` in interface `UnionType`
      Overrides:
        `getTypeName` in class `LocalUnionType`
      Returns:
        the name of this type. If the type is anonymous, an internally-generated type name is returned

    - #### getGenre

          public Genre getGenre()

      Get the genre of this item
      Specified by:
        `getGenre` in interface `ItemType`
      Overrides:
        `getGenre` in class `LocalUnionType`
      Returns:
        the genre

    - #### getBasicAlphaCode

          public java.lang.String getBasicAlphaCode()

      Get an alphabetic code representing the type, or at any rate, the nearest built-in type from which this type is derived. The codes are designed so that for any two built-in types A and B, alphaCode(A) is a prefix of alphaCode(B) if and only if A is a supertype of B.
      Specified by:
        `getBasicAlphaCode` in interface `ItemType`
      Overrides:
        `getBasicAlphaCode` in class `LocalUnionType`
      Returns:
        the alphacode for the nearest containing built-in type

    - #### containsListType

          public boolean containsListType()

      Ask whether the union contains a list type among its member types
      Specified by:
        `containsListType` in interface `UnionType`
      Overrides:
        `containsListType` in class `LocalUnionType`
      Returns:
        true of one of the member types is a list type

    - #### getPlainMemberTypes

          public java.lang.Iterable<AtomicType> getPlainMemberTypes()

      Get the "plain" types in the transitive membership. Plain types are atomic types and union types that are defined directly in terms of other plain types, without adding any restriction facets.
      Specified by:
        `getPlainMemberTypes` in interface `PlainType`
      Specified by:
        `getPlainMemberTypes` in interface `UnionType`
      Overrides:
        `getPlainMemberTypes` in class `LocalUnionType`
      Returns:
        the atomic types and plain union types in the transitive membership of the union type.

    - #### isNumericType

          public static boolean isNumericType​(ItemType type)

      Ask whether a given atomic type is numeric, that is, whether it is a subtype of xs:double, xs:float, or xs:decimal

    - #### getResultTypeOfCast

          public SequenceType getResultTypeOfCast()

      Get the result type of a cast operation to this union type, as a sequence type.
      Specified by:
        `getResultTypeOfCast` in interface `UnionType`
      Overrides:
        `getResultTypeOfCast` in class `LocalUnionType`
      Returns:
        the result type of casting, as precisely as possible. For example, if all the member types of the union are derived from the same primitive type, this will return that primitive type.

    - #### isPlainType

          public boolean isPlainType()

      Determine whether this item type is a plain type (that is, whether it can ONLY match atomic values)
      Specified by:
        `isPlainType` in interface `ItemType`
      Overrides:
        `isPlainType` in class `LocalUnionType`
      Returns:
        true if this is ANY_ATOMIC_TYPE or a subtype thereof, or a "plain" union type (that is, unions of atomic types that impose no further restrictions)

    - #### getDefaultPriority

          public double getDefaultPriority()

      Get the default priority when this ItemType is used as an XSLT pattern
      Specified by:
        `getDefaultPriority` in interface `ItemType`
      Overrides:
        `getDefaultPriority` in class `LocalUnionType`
      Returns:
        the default priority. This is the same as the union type (xs:double, xs:float, xs:decimal), namely 0.125 (= 0.5 * 0.5 * 0.5)

    - #### matches

          public boolean matches​(Item item,
                                 TypeHierarchy th)

      Test whether a given item conforms to this type
      Specified by:
        `matches` in interface `ItemType`
      Specified by:
        `matches` in interface `PlainType`
      Overrides:
        `matches` in class `LocalUnionType`
      Parameters:
        `item` - The item to be tested
        `th` - The type hierarchy cache
      Returns:
        true if the item is an instance of this type; false otherwise

    - #### getPrimitiveItemType

          public AtomicType getPrimitiveItemType()

      Get the primitive item type corresponding to this item type. For item(), this is Type.ITEM. For node(), it is Type.NODE. For specific node kinds, it is the value representing the node kind, for example Type.ELEMENT. For anyAtomicValue and union types it is Type.ATOMIC_VALUE. For numeric it is Type.NUMBER. For other atomic types it is the primitive type as defined in XML Schema, except that integer, xs:dayTimeDuration, and xs:yearMonthDuration are considered to be primitive types.
      Specified by:
        `getPrimitiveItemType` in interface `ItemType`
      Specified by:
        `getPrimitiveItemType` in interface `PlainType`
      Overrides:
        `getPrimitiveItemType` in class `LocalUnionType`
      Returns:
        the corresponding primitive type

    - #### getPrimitiveType

          public int getPrimitiveType()

      Get the primitive type corresponding to this item type. For item(), this is Type.ITEM. For node(), it is Type.NODE. For specific node kinds, it is the value representing the node kind, for example Type.ELEMENT. For anyAtomicValue it is BuiltInAtomicType.ANY_ATOMIC. For numeric it is Type.NUMBER. For other atomic types it is the primitive type as defined in XML Schema, except that INTEGER is considered to be a primitive type.
      Specified by:
        `getPrimitiveType` in interface `ItemType`
      Overrides:
        `getPrimitiveType` in class `LocalUnionType`
      Returns:
        the integer fingerprint of the corresponding primitive type

    - #### getUType

          public UType getUType()

      Get the corresponding `UType`. A UType is a union of primitive item types.
      Specified by:
        `getUType` in interface `ItemType`
      Overrides:
        `getUType` in class `LocalUnionType`
      Returns:
        the smallest UType that subsumes this item type

    - #### getAtomizedItemType

          public PlainType getAtomizedItemType()

      Get the item type of the atomic values that will be produced when an item of this type is atomized
      Specified by:
        `getAtomizedItemType` in interface `ItemType`
      Overrides:
        `getAtomizedItemType` in class `LocalUnionType`
      Returns:
        the best available item type of the atomic values that will be produced when an item of this type is atomized, or null if it is known that atomization will throw an error.

    - #### isAtomizable

          public boolean isAtomizable​(TypeHierarchy th)

      Ask whether values of this type are atomizable
      Specified by:
        `isAtomizable` in interface `ItemType`
      Overrides:
        `isAtomizable` in class `LocalUnionType`
      Parameters:
        `th` - The type hierarchy cache
      Returns:
        true unless it is known that these items will be elements with element-only content, or function items, in which case return false

    - #### isAtomicType

          public boolean isAtomicType()

      Test whether this Simple Type is an atomic type
      Specified by:
        `isAtomicType` in interface `ItemType`
      Specified by:
        `isAtomicType` in interface `SchemaType`
      Specified by:
        `isAtomicType` in interface `SimpleType`
      Overrides:
        `isAtomicType` in class `LocalUnionType`
      Returns:
        true if this is an atomic type

    - #### isListType

          public boolean isListType()

      Test whether this Simple Type is a list type
      Specified by:
        `isListType` in interface `SimpleType`
      Overrides:
        `isListType` in class `LocalUnionType`
      Returns:
        true if this is a list type

    - #### isUnionType

          public boolean isUnionType()

      Test whether this Simple Type is a union type
      Specified by:
        `isUnionType` in interface `SimpleType`
      Overrides:
        `isUnionType` in class `LocalUnionType`
      Returns:
        true if this is a union type

    - #### isBuiltInType

          public boolean isBuiltInType()

      Determine whether this is a built-in type or a user-defined type
      Specified by:
        `isBuiltInType` in interface `SimpleType`
      Overrides:
        `isBuiltInType` in class `LocalUnionType`
      Returns:
        true if this is a built-in type

    - #### getBuiltInBaseType

          public SchemaType getBuiltInBaseType()

      Get the built-in type from which this type is derived by restriction
      Specified by:
        `getBuiltInBaseType` in interface `SimpleType`
      Returns:
        the built-in type from which this type is derived by restriction. This will not necessarily be a primitive type.

    - #### getTypedValue

          public DoubleValue getTypedValue​(java.lang.CharSequence value,
                                           NamespaceResolver resolver,
                                           ConversionRules rules)
                                    throws ValidationException

      Get the typed value corresponding to a given string value, assuming it is valid against this type
      Specified by:
        `getTypedValue` in interface `SimpleType`
      Specified by:
        `getTypedValue` in interface `UnionType`
      Overrides:
        `getTypedValue` in class `LocalUnionType`
      Parameters:
        `value` - the string value
        `resolver` - a namespace resolver used to resolve any namespace prefixes appearing in the content of values. Can supply null, in which case any namespace-sensitive content will be rejected.
        `rules` - the conversion rules from the configuration
      Returns:
        an iterator over the atomic sequence comprising the typed value. The objects returned by this SequenceIterator will all be of type `AtomicValue`, The next() method on the iterator throws no checked exceptions, although it is not actually declared as an UnfailingIterator.
      Throws:
        `ValidationException` - if the supplied value is not in the lexical space of the data type

    - #### validateContent

          public ValidationFailure validateContent​(java.lang.CharSequence value,
                                                   NamespaceResolver nsResolver,
                                                   ConversionRules rules)

      Check whether a given input string is valid according to this SimpleType
      Specified by:
        `validateContent` in interface `SimpleType`
      Overrides:
        `validateContent` in class `LocalUnionType`
      Parameters:
        `value` - the input string to be checked
        `nsResolver` - a namespace resolver used to resolve namespace prefixes if the type is namespace sensitive. The value supplied may be null; in this case any namespace-sensitive content will throw an UnsupportedOperationException.
        `rules` - the conversion rules from the configuration
      Returns:
        null if validation succeeds; or return a ValidationFailure describing the validation failure if validation fails. Note that the exception is returned rather than being thrown.
      Throws:
        `java.lang.UnsupportedOperationException` - if the type is namespace-sensitive and no namespace resolver is supplied

    - #### checkAgainstFacets

          public ValidationFailure checkAgainstFacets​(AtomicValue value,
                                                      ConversionRules rules)

      Validate an atomic value, which is known to be an instance of one of the member types of the union, against any facets (pattern facets or enumeration facets) defined at the level of the union itself.
      Specified by:
        `checkAgainstFacets` in interface `UnionType`
      Overrides:
        `checkAgainstFacets` in class `LocalUnionType`
      Parameters:
        `value` - the Atomic Value to be checked. This must be an instance of a member type of the union
        `rules` - the ConversionRules for the Configuration
      Returns:
        a ValidationFailure if the value is not valid; null if it is valid.

    - #### isNamespaceSensitive

          public boolean isNamespaceSensitive()

      Test whether this type is namespace sensitive, that is, if a namespace context is needed to translate between the lexical space and the value space. This is true for types derived from, or containing, QNames and NOTATIONs
      Specified by:
        `isNamespaceSensitive` in interface `PlainType`
      Specified by:
        `isNamespaceSensitive` in interface `SimpleType`
      Overrides:
        `isNamespaceSensitive` in class `LocalUnionType`
      Returns:
        true if the type is namespace-sensitive

    - #### getWhitespaceAction

          public int getWhitespaceAction()

      Determine how values of this simple type are whitespace-normalized.
      Specified by:
        `getWhitespaceAction` in interface `SimpleType`
      Returns:
        one of `Whitespace.PRESERVE`, `Whitespace.COLLAPSE`, `Whitespace.REPLACE`.

    - #### preprocess

          public java.lang.CharSequence preprocess​(java.lang.CharSequence input)

      Apply any pre-lexical facets, other than whitespace. At the moment the only such facet is saxon:preprocess
      Specified by:
        `preprocess` in interface `SimpleType`
      Parameters:
        `input` - the value to be preprocessed
      Returns:
        the value after preprocessing

    - #### postprocess

          public java.lang.CharSequence postprocess​(java.lang.CharSequence input)

      Reverse any pre-lexical facets, other than whitespace. At the moment the only such facet is saxon:preprocess. This is called when converting a value of this type to a string
      Specified by:
        `postprocess` in interface `SimpleType`
      Parameters:
        `input` - the value to be postprocessed: this is the "ordinary" result of converting the value to a string
      Returns:
        the value after postprocessing

    - #### getName

          public java.lang.String getName()

      Get the local name of this type
      Specified by:
        `getName` in interface `SchemaType`
      Returns:
        the local name of this type definition, if it has one. Return null in the case of an anonymous type.

    - #### getTargetNamespace

          public java.lang.String getTargetNamespace()

      Get the target namespace of this type
      Specified by:
        `getTargetNamespace` in interface `SchemaType`
      Returns:
        the target namespace of this type definition, if it has one. Return null in the case of an anonymous type, and in the case of a global type defined in a no-namespace schema.

    - #### getFingerprint

          public int getFingerprint()

      Get the fingerprint of the name of this type
      Specified by:
        `getFingerprint` in interface `SchemaType`
      Returns:
        the fingerprint. Returns an invented fingerprint for an anonymous type.

    - #### getDisplayName

          public java.lang.String getDisplayName()

      Get the display name of the type: that is, a lexical QName with an arbitrary prefix
      Specified by:
        `getDisplayName` in interface `SchemaType`
      Returns:
        a lexical QName identifying the type. In the case of an anonymous type, an internally-generated name is returned

    - #### getEQName

          public java.lang.String getEQName()

      Get the name of this type as an EQName, that is, a string in the format Q{uri}local.
      Specified by:
        `getEQName` in interface `SchemaType`
      Returns:
        an EQName identifying the type. In the case of an anonymous type, an internally-generated name is returned

    - #### getStructuredQName

          public StructuredQName getStructuredQName()

      Get the name of the type as a StructuredQName
      Specified by:
        `getStructuredQName` in interface `SchemaType`
      Specified by:
        `getStructuredQName` in interface `UnionType`
      Returns:
        a StructuredQName identifying the type. In the case of an anonymous type, an internally-generated name is returned

    - #### isComplexType

          public boolean isComplexType()

      Test whether this SchemaType is a complex type
      Specified by:
        `isComplexType` in interface `SchemaType`
      Returns:
        true if this SchemaType is a complex type

    - #### isSimpleType

          public boolean isSimpleType()

      Test whether this SchemaType is a simple type
      Specified by:
        `isSimpleType` in interface `SchemaType`
      Returns:
        true if this SchemaType is a simple type

    - #### isAnonymousType

          public boolean isAnonymousType()

      Test whether this is an anonymous type
      Specified by:
        `isAnonymousType` in interface `SchemaType`
      Returns:
        true if this SchemaType is an anonymous type

    - #### getBlock

          public int getBlock()

      Returns the value of the 'block' attribute for this type, as a bit-significant integer with fields such as `SchemaType.DERIVATION_LIST` and `SchemaType.DERIVATION_EXTENSION`. This corresponds to the property "prohibited substitutions" in the schema component model.
      Specified by:
        `getBlock` in interface `SchemaType`
      Returns:
        the value of the 'block' attribute for this type

    - #### getBaseType

          public SchemaType getBaseType()

      Returns the base type that this type inherits from. This method can be used to get the base type of a type that is known to be valid. If this type is a Simpletype that is a built in primitive type then null is returned.
      Specified by:
        `getBaseType` in interface `SchemaType`
      Returns:
        the base type, or null if this is xs:anyType (the root of the type hierarchy)

    - #### getDerivationMethod

          public int getDerivationMethod()

      Gets the integer code of the derivation method used to derive this type from its parent. Returns zero for primitive types.
      Specified by:
        `getDerivationMethod` in interface `SchemaType`
      Returns:
        a numeric code representing the derivation method, for example `SchemaType.DERIVATION_RESTRICTION`

    - #### getFinalProhibitions

          public int getFinalProhibitions()

      Get the types of derivation that are not permitted, by virtue of the "final" property.
      Specified by:
        `getFinalProhibitions` in interface `SchemaType`
      Returns:
        the types of derivation that are not permitted, as a bit-significant integer containing bits such as `SchemaType.DERIVATION_EXTENSION`

    - #### allowsDerivation

          public boolean allowsDerivation​(int derivation)

      Determines whether derivation (of a particular kind) from this type is allowed, based on the "final" property
      Specified by:
        `allowsDerivation` in interface `SchemaType`
      Parameters:
        `derivation` - the kind of derivation, for example `SchemaType.DERIVATION_LIST`
      Returns:
        true if this kind of derivation is allowed

    - #### analyzeContentExpression

          public void analyzeContentExpression​(Expression expression,
                                               int kind)
                                        throws XPathException

      Analyze an XPath expression to see whether the expression is capable of delivering a value of this type. This method is called during static analysis of a query or stylesheet to give compile-time warnings when "impossible" paths are used.
      Specified by:
        `analyzeContentExpression` in interface `SchemaType`
      Parameters:
        `expression` - the expression that delivers the content
        `kind` - the node kind whose content is being delivered: `Type.ELEMENT`, `Type.ATTRIBUTE`, or `Type.DOCUMENT`
      Throws:
        `XPathException` - if the expression will never deliver a value of the correct type

    - #### atomize

          public AtomicSequence atomize​(NodeInfo node)
                                 throws XPathException

      Get the typed value of a node that is annotated with this schema type.
      Specified by:
        `atomize` in interface `SchemaType`
      Parameters:
        `node` - the node whose typed value is required
      Returns:
        the typed value.
      Throws:
        `XPathException` - if the node cannot be atomized, for example if this is a complex type with element-only content
      Since:
        8.5. Changed in 9.5 to return the new type AtomicSequence

    - #### isSameType

          public boolean isSameType​(SchemaType other)

      Test whether this is the same type as another type. They are considered to be the same type if they are derived from the same type definition in the original XML representation (which can happen when there are multiple includes of the same file)
      Specified by:
        `isSameType` in interface `SchemaType`
      Parameters:
        `other` - the other type
      Returns:
        true if this is the same type as other

    - #### getDescription

          public java.lang.String getDescription()

      Get a description of this type for use in error messages. This is the same as the display name in the case of named types; for anonymous types it identifies the type by its position in a source schema document.
      Specified by:
        `getDescription` in interface `SchemaType`
      Specified by:
        `getDescription` in interface `UnionType`
      Returns:
        text identifing the type, for use in a phrase such as "the type XXXX".

    - #### getSystemId

          public java.lang.String getSystemId()

      Get the URI of the schema document where the type was originally defined.
      Specified by:
        `getSystemId` in interface `SchemaType`
      Returns:
        the URI of the schema document. Returns null if the information is unknown or if this is a built-in type

    - #### isIdType

          public boolean isIdType()

      Ask whether this type is an ID type. This is defined to be any simple type who typed value may contain atomic values of type xs:ID: that is, it includes types derived from ID by restriction, list, or union. Note that for a node to be treated as an ID in XSD 1.0, its typed value must be a *single* atomic value of type ID; the type of the node, however, can still allow a list. But in XSD 1.1, a list of IDs is permitted
      Specified by:
        `isIdType` in interface `SchemaType`
      Overrides:
        `isIdType` in class `LocalUnionType`
      Returns:
        true if this type is an ID type

    - #### isIdRefType

          public boolean isIdRefType()

      Ask whether this type is an IDREF or IDREFS type. This is defined to be any simple type who typed value may contain atomic values of type xs:IDREF: that is, it includes types derived from IDREF or IDREFS by restriction, list, or union
      Specified by:
        `isIdRefType` in interface `SchemaType`
      Overrides:
        `isIdRefType` in class `LocalUnionType`
      Returns:
        true if this type is an IDREF type

    - #### getValidationStatus

          public SchemaComponent.ValidationStatus getValidationStatus()

      Get the validation status of this component.
      Specified by:
        `getValidationStatus` in interface `SchemaComponent`
      Returns:
        one of the values `SchemaComponent.ValidationStatus.UNVALIDATED`, `SchemaComponent.ValidationStatus.VALIDATING`, `SchemaComponent.ValidationStatus.VALIDATED`, `SchemaComponent.ValidationStatus.INVALID`, `SchemaComponent.ValidationStatus.INCOMPLETE`

    - #### getRedefinitionLevel

          public int getRedefinitionLevel()

      Get the redefinition level. This is zero for a component that has not been redefined; for a redefinition of a level-0 component, it is 1; for a redefinition of a level-N component, it is N+1. This concept is used to support the notion of "pervasive" redefinition: if a component is redefined at several levels, the top level wins, but it is an error to have two versions of the component at the same redefinition level.
      Specified by:
        `getRedefinitionLevel` in interface `SchemaComponent`
      Returns:
        the redefinition level

    - #### toExportString

          public java.lang.String toExportString()

      Return a string representation of this ItemType suitable for use in stylesheet export files. This differs from the result of toString() in that it will not contain any references to anonymous types. Note that it may also use the Saxon extended syntax for union types and tuple types. The default implementation returns the result of calling `toString()`.
      Specified by:
        `toExportString` in interface `ItemType`
      Overrides:
        `toExportString` in class `LocalUnionType`
      Returns:
        the string representation as an instance of the XPath SequenceType construct

    - #### toString

          public java.lang.String toString()

      Description copied from class: `LocalUnionType`
      Produce a string representation of the type name. If the type is anonymous, an internally-allocated type name will be returned.
      Specified by:
        `toString` in interface `ItemType`
      Overrides:
        `toString` in class `LocalUnionType`
      Returns:
        the name of the atomic type in the form Q{uri}local

    - #### checkTypeDerivationIsOK

          public void checkTypeDerivationIsOK​(SchemaType base,
                                              int block)
                                       throws SchemaException

      Check that this type is validly derived from a given type, following the rules for the Schema Component Constraint "Is Type Derivation OK (Simple)" (3.14.6) or "Is Type Derivation OK (Complex)" (3.4.6) as appropriate.
      Specified by:
        `checkTypeDerivationIsOK` in interface `SchemaType`
      Parameters:
        `base` - the base type; the algorithm tests whether derivation from this type is permitted
        `block` - the derivations that are blocked by the relevant element declaration
      Throws:
        `SchemaException` - if the derivation is not allowed

    - #### getComponentAsFunction

          public Function getComponentAsFunction()

      Get the schema component in the form of a function item. This allows schema information to be made visible to XSLT or XQuery code. The function makes available the contents of the schema component as defined in the XSD specification. The function takes a string as argument representing a property name, and returns the corresponding property of the schema component. There is also a property "class" which returns the kind of schema component, for example "Attribute Declaration".
      Specified by:
        `getComponentAsFunction` in interface `SchemaComponent`
      Returns:
        the schema component represented as a function from property names to property values.